#include <stdio.h>
#include <string.h>
#include "tait.h"





	/*******************************************************************
	 * PROCEDURE: init_globals
	 *
	 * DESCRIPTION: Initialize the values of a bunch of global
	 *              variables.  These are based on the COMMON
	 *              blocks in the old BASIC code, so some of these
	 *              may not be used.  
	 *
	 * RETURNS:
	 *    nothing
	 */

void
init_globals
	(
	)
{
	double offset;

	/* by default, we really do talk to the Mark IV unit */
	g_fake_flag = 0;

	/* Labels for the various DACs and ADCs */
	strncpy(g_labels[0],  "Water Temp 0 ", LABEL_LEN);
	strncpy(g_labels[1],  "VCO Temp     ", LABEL_LEN);
	strncpy(g_labels[2],  "VCO Reference", LABEL_LEN);
	strncpy(g_labels[3],  "Temp 1       ", LABEL_LEN);
	strncpy(g_labels[4],  "Temp 2       ", LABEL_LEN);
	strncpy(g_labels[5],  "Temp 3       ", LABEL_LEN);
	strncpy(g_labels[6],  "Temp CO DAC15", LABEL_LEN);
	strncpy(g_labels[7],  "Temp C3 DAC10", LABEL_LEN);
	strncpy(g_labels[8],  "Ground       ", LABEL_LEN);
	strncpy(g_labels[9],  "-15          ", LABEL_LEN);
	strncpy(g_labels[10], "-5           ", LABEL_LEN);
	strncpy(g_labels[11], "+5           ", LABEL_LEN);
	strncpy(g_labels[12], "+15          ", LABEL_LEN);
	strncpy(g_labels[13], "VCO DAC12    ", LABEL_LEN);
	strncpy(g_labels[14], "Temp C1 DAC14", LABEL_LEN);
	strncpy(g_labels[15], "Temp C2 DAC11", LABEL_LEN);
	strncpy(g_labels[16], "CCD Temp 2   ", LABEL_LEN);
	strncpy(g_labels[17], "CCD VDD Power", LABEL_LEN);
	strncpy(g_labels[18], "CCD Temp 0   ", LABEL_LEN);
	strncpy(g_labels[19], "CCD Temp 1   ", LABEL_LEN);
	strncpy(g_labels[20], "ADC Reference", LABEL_LEN);
	strncpy(g_labels[21], "VCH DAC 7    ", LABEL_LEN);
	strncpy(g_labels[22], "VRH DAC 2    ", LABEL_LEN);
	strncpy(g_labels[23], "VHL DAC 1    ", LABEL_LEN);
	strncpy(g_labels[24], "TEC Current 2", LABEL_LEN);
	strncpy(g_labels[25], "TEC Current 0", LABEL_LEN);
	strncpy(g_labels[26], "TEC Current 1", LABEL_LEN);
	strncpy(g_labels[27], "TEC Current 3", LABEL_LEN);
	strncpy(g_labels[28], "TEC Power    ", LABEL_LEN);
	strncpy(g_labels[29], "VVL DAC 6    ", LABEL_LEN);
	strncpy(g_labels[30], "VRL DAC 3    ", LABEL_LEN);
	strncpy(g_labels[31], "VHH DAC 0    ", LABEL_LEN);
	strncpy(g_labels[32], "Power Supply Voltages", LABEL_LEN);
	strncpy(g_labels[33], "DAC Commands         ", LABEL_LEN);
	/* following is the PC software version label */
	strncpy(g_labels[34], "", LABEL_LEN);
	/* following is the PC software sub-version label */
	strncpy(g_labels[35], "", LABEL_LEN);
	strncpy(g_labels[36], "Status               ", LABEL_LEN);
	strncpy(g_labels[37], "Running ADC Scan     ", LABEL_LEN);
	strncpy(g_labels[38], "Done                 ", LABEL_LEN);
	strncpy(g_labels[39], "ADC Channel  Value  Offset  Scale", LABEL_LEN);
	strncpy(g_labels[40], "Loading the DACs     ", LABEL_LEN);
	strncpy(g_labels[41], "Software Version     ", LABEL_LEN);
	strncpy(g_labels[42], "PC Version           ", LABEL_LEN);
	strncpy(g_labels[43], "Stamp Version        ", LABEL_LEN);
	/* following is the Stamp software version */
	strncpy(g_labels[44], "x                    ", LABEL_LEN);
	/* following is the Stamp software sub-version */
	strncpy(g_labels[45], "x                    ", LABEL_LEN);

	strncpy(g_labels[64], "VHH B D0     ", LABEL_LEN);
	strncpy(g_labels[65], "VHL A D1     ", LABEL_LEN);
	strncpy(g_labels[66], "VRH J D2     ", LABEL_LEN);
	strncpy(g_labels[67], "VRL I D3     ", LABEL_LEN);
	strncpy(g_labels[68], "TR ADC3 N D4 ", LABEL_LEN);
	strncpy(g_labels[69], "TR ADC2 M D5 ", LABEL_LEN);
	strncpy(g_labels[70], "VVL L D6     ", LABEL_LEN);
	strncpy(g_labels[71], "VVH K D7     ", LABEL_LEN);
	strncpy(g_labels[72], "TR ADC1 P D8 ", LABEL_LEN);
	strncpy(g_labels[73], "TR ADC0 O D9 ", LABEL_LEN);
	strncpy(g_labels[74], "T COM3 S D10 ", LABEL_LEN);
	strncpy(g_labels[75], "T COM2 R D11 ", LABEL_LEN);
	strncpy(g_labels[76], "VCO W D12    ", LABEL_LEN);
	strncpy(g_labels[77], "Spare V D13  ", LABEL_LEN);
	strncpy(g_labels[78], "T COM1 U D14 ", LABEL_LEN);
	strncpy(g_labels[79], "T COM0 T D15 ", LABEL_LEN);

	/* load these initial command voltages into the DACs */
	g_voltages[0] = 6;
	g_voltages[1] = -3;
	g_voltages[2] = 0;
	g_voltages[3] = 7;
	g_voltages[4] = 2;
	g_voltages[5] = 3;
	g_voltages[6] = -8;
	g_voltages[7] = 3.9;
	g_voltages[8] = 0;
	g_voltages[9] = 0;
	g_voltages[10] = 6;
	g_voltages[11] = 7;
	g_voltages[12] = 3;
	g_voltages[13] = 9;
	g_voltages[14] = 3;
	g_voltages[15] = 3;

	/* these are the ADC data values */
	offset = 0;
	g_adc[0][0]  = offset - 2.73;
	g_adc[1][0]  = offset - 2.73;
	g_adc[2][0]  = offset;
	g_adc[3][0]  = offset - 2.73;
	g_adc[4][0]  = offset - 2.73;
	g_adc[5][0]  = offset - 2.73;
	g_adc[6][0]  = offset;
	g_adc[7][0]  = offset;
	g_adc[8][0]  = offset;
	g_adc[9][0]  = offset;
	g_adc[10][0] = offset;
	g_adc[11][0] = offset;
	g_adc[12][0] = offset;
	g_adc[13][0] = offset;
	g_adc[14][0] = offset;
	g_adc[15][0] = offset;
	g_adc[16][0] = offset - 2.73;
	g_adc[17][0] = offset;
	g_adc[18][0] = offset - 2.73;
	g_adc[19][0] = offset - 2.73;
	g_adc[20][0] = offset;
	g_adc[21][0] = offset;
	g_adc[22][0] = offset;
	g_adc[23][0] = offset;
	g_adc[24][0] = offset;
	g_adc[25][0] = offset;
	g_adc[26][0] = offset;
	g_adc[27][0] = offset;
	g_adc[28][0] = offset;
	g_adc[29][0] = offset;
	g_adc[30][0] = offset;
	g_adc[31][0] = offset;
	g_adc[0][1]  = 100;
	g_adc[1][1]  = 100;
	g_adc[2][1]  = 1;
	g_adc[3][1]  = 100;
	g_adc[4][1]  = 100;
	g_adc[5][1]  = 100;
	g_adc[6][1]  = 1;
	g_adc[7][1]  = 1;
	g_adc[8][1]  = 1;
	g_adc[9][1]  = 10;
	g_adc[10][1] = 1;
	g_adc[11][1] = 1;
	g_adc[12][1] = 10;
	g_adc[13][1] = 1;
	g_adc[14][1] = 1;
	g_adc[15][1] = 1;
	g_adc[16][1] = 100;
	g_adc[17][1] = 10;
	g_adc[18][1] = 100;
	g_adc[19][1] = 100;
	g_adc[20][1] = 1;
	g_adc[21][1] = 1;
	g_adc[22][1] = 1;
	g_adc[23][1] = 1;
	g_adc[24][1] = 10;
	g_adc[25][1] = 10;
	g_adc[26][1] = 10;
	g_adc[27][1] = 10;
	g_adc[28][1] = 10;
	g_adc[29][1] = 1;
	g_adc[30][1] = 1;
	g_adc[31][1] = 1;

}
